# Jabalizer Documentation

```@meta
CurrentModule = Jabalizer
```

## Contents

```@contents
```

## Types

```@docs
Stabilizer
StabilizerState
GraphState
```

## Functions

### State preparation

```@docs
AddQubit
AddQubits
AddBell
AddGHZ
AddGraph
```

### Gates

```@docs
Id
X
Y
Z
H
P
SWAP
CNOT
CZ
FusionI
FusionII
```

### Channels

```@docs
ChannelX
ChannelY
ChannelZ
ChannelPauli
ChannelDepol
ChannelLoss
```

### Utilities

```@docs
RowAdd
print
string
*
```

## Index

```@index
```
