var documenterSearchIndex = {"docs":
[{"location":"#Jabalizer-Documentation","page":"Jabalizer Documentation","title":"Jabalizer Documentation","text":"","category":"section"},{"location":"","page":"Jabalizer Documentation","title":"Jabalizer Documentation","text":"CurrentModule = Jabalizer","category":"page"},{"location":"#Contents","page":"Jabalizer Documentation","title":"Contents","text":"","category":"section"},{"location":"","page":"Jabalizer Documentation","title":"Jabalizer Documentation","text":"","category":"page"},{"location":"#Types","page":"Jabalizer Documentation","title":"Types","text":"","category":"section"},{"location":"","page":"Jabalizer Documentation","title":"Jabalizer Documentation","text":"Stabilizer\nStabilizerState\nGraphState","category":"page"},{"location":"#Main.Jabalizer.Stabilizer","page":"Jabalizer Documentation","title":"Main.Jabalizer.Stabilizer","text":"Stabilizer type\n\nType for a single stabilizer in the n-qubit Pauli group.\n\n\n\n\n\n","category":"type"},{"location":"#Main.Jabalizer.StabilizerState","page":"Jabalizer Documentation","title":"Main.Jabalizer.StabilizerState","text":"Stabilizer state type.\n\nqubits: number of qubits. stabilizers: set of state stabilizers. labels: qubit labels.\n\n\n\n\n\n","category":"type"},{"location":"#Main.Jabalizer.GraphState","page":"Jabalizer Documentation","title":"Main.Jabalizer.GraphState","text":"Graph state type\n\nType for a stabilizer state constrained to graph form.\n\n\n\n\n\n","category":"type"},{"location":"#Functions","page":"Jabalizer Documentation","title":"Functions","text":"","category":"section"},{"location":"#State-preparation","page":"Jabalizer Documentation","title":"State preparation","text":"","category":"section"},{"location":"","page":"Jabalizer Documentation","title":"Jabalizer Documentation","text":"AddQubit\nAddQubits\nAddBell\nAddGHZ\nAddGraph","category":"page"},{"location":"#Main.Jabalizer.AddQubit","page":"Jabalizer Documentation","title":"Main.Jabalizer.AddQubit","text":"Add a qubit to a stabilizer with given Pauli operator and phase.\n\n\n\n\n\nAdd a qubit to a stabilizer with identity operator.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.AddQubits","page":"Jabalizer Documentation","title":"Main.Jabalizer.AddQubits","text":"Add multiple qubits to a Stabilizer.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.AddBell","page":"Jabalizer Documentation","title":"Main.Jabalizer.AddBell","text":"AddBell(state, labelA, labelB)\n\nAdd Bell state (00rangle+11rangle)sqrt2 to a State.\n\n\n\n\n\nAddBell(state)\n\nAdd Bell state (00rangle+11rangle)sqrt2 to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.AddGHZ","page":"Jabalizer Documentation","title":"Main.Jabalizer.AddGHZ","text":"AddGHZ(state, size, labels)\n\nAdd a GHZ state to a State.\n\n\n\n\n\nAddGHZ(state, size)\n\nAdd a GHZ state to a State.\n\n\n\n\n\nAddGHZ(state)\n\nAdd a 3-qubit GHZ state to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.AddGraph","page":"Jabalizer Documentation","title":"Main.Jabalizer.AddGraph","text":"AddGraph(state, graph, labels)\n\nAdd a graph state to a State.\n\n\n\n\n\nAddGraph(state, graph)\n\nAdd a graph state to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Gates","page":"Jabalizer Documentation","title":"Gates","text":"","category":"section"},{"location":"","page":"Jabalizer Documentation","title":"Jabalizer Documentation","text":"Id\nX\nY\nZ\nH\nP\nSWAP\nCNOT\nCZ\nFusionI\nFusionII","category":"page"},{"location":"#Main.Jabalizer.Id","page":"Jabalizer Documentation","title":"Main.Jabalizer.Id","text":"Here's some inline maths: sqrtn1 + x + x^2 + ldots.\n\nHere's an equation:\n\nfracnk(n - k) = binomnk\n\nThis is the binomial coefficient.\n\n\n\n\n\nId(state, qubit)\n\nApply I gate to a State on qubit.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.X","page":"Jabalizer Documentation","title":"Main.Jabalizer.X","text":"X(stabilizer, qubit)\n\nApply Pauli-X gate to a stabilizer.\n\n\n\n\n\nX(state, qubit)\n\nApply X gate to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.Y","page":"Jabalizer Documentation","title":"Main.Jabalizer.Y","text":"Y(stabilizer, qubit)\n\nApply Y gate to a stabilizer.\n\n\n\n\n\nY(state, qubit)\n\nApply Y gate to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.Z","page":"Jabalizer Documentation","title":"Main.Jabalizer.Z","text":"Z(stabilizer, qubit)\n\nApply Z gate to a stabilizer.\n\n\n\n\n\nZ(state, qubit)\n\nApply Z gate to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.H","page":"Jabalizer Documentation","title":"Main.Jabalizer.H","text":"H(stabilizer, qubit)\n\nApply H gate to a stabilizer.\n\n\n\n\n\nH(state, qubit)\n\nApply H gate to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.P","page":"Jabalizer Documentation","title":"Main.Jabalizer.P","text":"P(stabilizer, qubit)\n\nApply the P=sqrtZ gate to a stabilizer.\n\n\n\n\n\nP(state, qubit)\n\nApply P gate to a state on qubit.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.SWAP","page":"Jabalizer Documentation","title":"Main.Jabalizer.SWAP","text":"SWAP(stabilizer, qubit1, qubit2)\n\nApply SWAP gate to a Stabilizer.\n\n\n\n\n\nSWAP(state, first, second)\n\nApply SWAP gate to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.CNOT","page":"Jabalizer Documentation","title":"Main.Jabalizer.CNOT","text":"CNOT(Stabilizer, control, target)\n\nApply CNOT gate to a Stabilizer.\n\n\n\n\n\nCNOT(state, control, target)\n\nApply CNOT gate to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.CZ","page":"Jabalizer Documentation","title":"Main.Jabalizer.CZ","text":"CZ(state, control, target)\n\nApply CZ gate to a Stabilizer.\n\n\n\n\n\nCZ(state, control, target)\n\nApply CZ gate to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.FusionI","page":"Jabalizer Documentation","title":"Main.Jabalizer.FusionI","text":"FusionI(state, first, second)\n\nApply type-I fusion gate to a state.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.FusionII","page":"Jabalizer Documentation","title":"Main.Jabalizer.FusionII","text":"FusionII(state, first, second)\n\nApply type-II fusion gate to a state.\n\n\n\n\n\n","category":"function"},{"location":"#Channels","page":"Jabalizer Documentation","title":"Channels","text":"","category":"section"},{"location":"","page":"Jabalizer Documentation","title":"Jabalizer Documentation","text":"ChannelX\nChannelY\nChannelZ\nChannelPauli\nChannelDepol\nChannelLoss","category":"page"},{"location":"#Main.Jabalizer.ChannelX","page":"Jabalizer Documentation","title":"Main.Jabalizer.ChannelX","text":"ChannelX(State, qubit, prob)\n\nApply Pauli-X channel gate to a State.\n\n\n\n\n\nChannelX(State, prob)\n\nApply Pauli-X channel gate to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.ChannelY","page":"Jabalizer Documentation","title":"Main.Jabalizer.ChannelY","text":"ChannelY(State, qubit, prob)\n\nApply Pauli-Y channel gate to a State.\n\n\n\n\n\nChannelY(State, prob)\n\nApply Pauli-Y channel gate to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.ChannelZ","page":"Jabalizer Documentation","title":"Main.Jabalizer.ChannelZ","text":"ChannelZ(State, qubit, prob)\n\nApply Pauli-Z channel gate to a State.\n\n\n\n\n\nChannelZ(State, prob)\n\nApply Pauli-Z channel gate to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.ChannelPauli","page":"Jabalizer Documentation","title":"Main.Jabalizer.ChannelPauli","text":"ChannelPauli(State, qubit, probs)\n\nApply general Pauli channel gate to a State.\n\n\n\n\n\nChannelPauli(State, prob)\n\nApply general Pauli channel gate to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.ChannelDepol","page":"Jabalizer Documentation","title":"Main.Jabalizer.ChannelDepol","text":"ChannelDepol(State, qubit, prob)\n\nApply depolarizing channel gate to a State.\n\n\n\n\n\nChannelDepol(State, prob)\n\nApply depolarizing channel gate to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Main.Jabalizer.ChannelLoss","page":"Jabalizer Documentation","title":"Main.Jabalizer.ChannelLoss","text":"ChannelLoss(State, qubit, prob)\n\nApply loss channel gate to a State.\n\n\n\n\n\nChannelLoss(State, prob)\n\nApply loss channel gate to a State.\n\n\n\n\n\n","category":"function"},{"location":"#Utilities","page":"Jabalizer Documentation","title":"Utilities","text":"","category":"section"},{"location":"","page":"Jabalizer Documentation","title":"Jabalizer Documentation","text":"RowAdd\nprint\nstring\n*","category":"page"},{"location":"#Main.Jabalizer.RowAdd","page":"Jabalizer Documentation","title":"Main.Jabalizer.RowAdd","text":"RowAdd(tableau, source, dest)\n\nRow addition operation for tableaus.\n\n\n\n\n\n","category":"function"},{"location":"#Base.print","page":"Jabalizer Documentation","title":"Base.print","text":"print(stabilizer)\n\nPrint a stabilizer to terminal.\n\n\n\n\n\nprint(state)\n\nPrint the full stabilizer set of a state to the terminal.\n\n\n\n\n\nprint(graphState)\n\nPrint a GraphState to the terminal.\n\n\n\n\n\n","category":"function"},{"location":"#Base.string","page":"Jabalizer Documentation","title":"Base.string","text":"string(stabilizer)\n\nConvert stabilizer to string.\n\n\n\n\n\nstring(state)\n\nConvert state to string.\n\n\n\n\n\n","category":"function"},{"location":"#Base.:*","page":"Jabalizer Documentation","title":"Base.:*","text":"*(left,right)\n\nMultiplication operator for stabilizers.\n\n\n\n\n\n","category":"function"},{"location":"#Index","page":"Jabalizer Documentation","title":"Index","text":"","category":"section"},{"location":"","page":"Jabalizer Documentation","title":"Jabalizer Documentation","text":"","category":"page"}]
}
